unit PasFrmMain;

interface

uses
  System.SysUtils, System.Types, System.UITypes, System.Classes, System.Variants,
  FMX.Types, FMX.Controls, FMX.Forms, FMX.Graphics, FMX.Dialogs,
  FMX.Controls.Presentation, FMX.StdCtrls, Androidapi.JNI.App
  ,Androidapi.JNIBridge
  ,Androidapi.JNI.GraphicsContentViewText
  ,Androidapi.JNI.JavaTypes
  ,Androidapi.JNI.Os
  ,FMX.Helpers.Android
  ,Androidapi.Helpers
  ,Androidapi.JNI.ActivityManager;

type
  TForm8 = class(TForm)
    Button2: TButton;
    lFreeMem: TLabel;
    LAllMem: TLabel;
    Button3: TButton;
    Label1: TLabel;
    Timer1: TTimer;
    procedure Button2Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    am: JActivityManager;
    mi: JActivityManager_MemoryInfo;

    sa : TStringList;

    function ServiceIsStarted: Boolean;
    procedure memInfo;
  end;

var
  Form8: TForm8;

implementation

{$R *.fmx}


procedure TForm8.Button2Click(Sender: TObject);
var
  I: Integer;
begin
 for I := 0 to 400000 do
  Begin
   sa.Add('XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX');
  End;

  Button2.Text := 'nr. strings in mem:' + sa.Count.ToString();
(* if ServiceIsStarted then
  ShowMessage('yes')
 Else
  ShowMessage('no'); *)
end;

procedure TForm8.Button3Click(Sender: TObject);
begin
 sa.Clear;
end;

procedure TForm8.FormCreate(Sender: TObject);
begin
 am:= GetActivityManager;
 mi:=TJActivityManager_MemoryInfo.Create;
 sa := TStringList.Create;


 am.getMemoryInfo(mi);
 lFreeMem.Text:='Free Memory: '+(mi.availMem div 1048576).ToString()+'Mb';
 LAllMem.Text:='All Memory: '+(mi.totalMem div 1048576).ToString()+'Mb';

end;

procedure TForm8.memInfo;
var
  mi:JActivityManager_MemoryInfo;
  am:JActivityManager;
  ah:TAndroidHelper;
begin
   ah:=TAndroidHelper.Create;
   am:=ah.Activity.getSystemService(StringToJString('ACTIVITY_SERVICE')) as JActivityManager;

    mi:=TJActivityManager_MemoryInfo.Create;
    am.getMemoryInfo(mi);
    ShowMessage('FreeMem/AllMem: '+mi.availMem.ToString()+'/'+mi.totalMem.ToString());

end;

function GetActivityManager: JActivityManager;
var
  ActivityManagerNative: JObject;
begin
  ActivityManagerNative := SharedActivityContext.getSystemService(TJContext.JavaClass.ACTIVITY_SERVICE);
  if not Assigned(ActivityManagerNative) then
    raise Exception.Create('Could not locate Activity Service');
  Result := TJActivityManager.Wrap(
    (ActivityManagerNative as ILocalObject).GetObjectID);
  if not Assigned(Result) then
    raise Exception.Create('Could not access Activity Manager');
end;


function TForm8.ServiceIsStarted: Boolean;
var
  ActivityServiceManager: JObject;
  FActivityManager : JActivityManager;
  List: JList;
  Iterator: JIterator;
  ri: JActivityManager_RunningServiceInfo;
  s: String;
begin

  Result := False;
  ActivityServiceManager := TAndroidHelper.Context.getSystemService(TJContext.JavaClass.ACTIVITY_SERVICE);
  FActivityManager := TJActivityManager.Wrap((ActivityServiceManager as ILocalObject).GetObjectID);
  List := FActivityManager.getRunningServices(MAXINT);
  Iterator := List.iterator;
  while Iterator.hasNext and (not Result) do
  begin
    ri := TJActivityManager_RunningServiceInfo.Wrap((Iterator.next as ILocalObject).GetObjectID);
    s := JStringToString(ri.service.getClassName);
    Result := (s = 'com.embarcadero.services.MyService');
  end;

end;

procedure TForm8.Timer1Timer(Sender: TObject);
begin
  am.getMemoryInfo(mi);
  lFreeMem.Text:='Free Memory: '+(mi.availMem div 1048576).ToString()+'Mb';
  LAllMem.Text:='All Memory: '+(mi.totalMem div 1048576).ToString()+'Mb';
end;

end.
